VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TCAinstDB"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const cmOpenForReading = 1

Public m_lError As Long
Public m_sLogFile As String
Public m_oCurForm As Object

Private m_lTotal As Long
Private m_lLoaded As Long
Private m_lNotLoaded As Long
Private m_oConnect As TConnection

Private Const cmGoStatement As String = "GO"
Private Const cmSQLFilesFilter As String = "*.sql"
Private Const cmBackSlash As String = "\"


Public Sub LoadStoredProcs(ByVal sPath As String, _
                            ByVal sServer As String, ByVal sDatabase As String, _
                            ByVal sUser As String, ByVal sPassword As String, _
                            Optional ByVal sLoginNT As String = vbNullString)

On Error GoTo Error_Handler

    Dim bNotAFile As Boolean, bConnect  As Boolean, bContinue As Boolean, bMsgProcRestantes As Boolean
    Dim lRet As Long, lProcRestantes As Long, lCpt As Long, lDebut As Long, lDuree As Long
    Dim sDSN As String, sLine As String
    Dim Fs As Object, oFileSource As Object
    Dim colFilesTemp As CCollection, colFiles As CCollection
    
    bNotAFile = False
    bMsgProcRestantes = False
    lDebut = GetTickCount
    
    '' Construit le DSN de connexion  la base
    If sUser <> vbNullString Then
        sDSN = "uid=" & sUser & ";pwd=" & sPassword & ";driver={SQL Server};server=" & sServer & ";database=" & sDatabase & ";dsn=''"
    Else
        sDSN = "driver={SQL Server};server=" & sServer & ";database=" & sDatabase & ";dsn=''"
    End If
    
    '' Ouvre la connexion
    Set m_oConnect = New TConnection
    bConnect = m_oConnect.OpenConnection(sDSN)
    
    '' Si la connexion a choue
    If Not bConnect Then
        '' Avertit l'utilisateur
        If sUser <> vbNullString Then
            MessageBox "La connection suivante a choue (" & Format(Now, "dd/mm/yyyy hh:mm:ss") & ") : " & vbNewLine & _
                   "    Serveur : " & sServer & vbNewLine & _
                   "    Base : " & sDatabase & vbNewLine & _
                   "    User : " & sUser & vbNewLine & _
                   "    Password : " & sPassword
        Else
            MessageBox "La connection suivante a choue (" & Format(Now, "dd/mm/yyyy hh:mm:ss") & ") : " & vbNewLine & _
                   "    Serveur : " & sServer & vbNewLine & _
                   "    Base : " & sDatabase & vbNewLine
        End If
        '' Stoppe le traitement
        Exit Sub
    
    '' Si la connexion est valide
    ElseIf LenB(m_sLogFile) > 0 Then
        '' Avertit l'utilisateur
        If sUser <> vbNullString Then
            MessageBox "Dploiement (" & Format(Now, "dd/mm/yyyy hh:mm:ss") & ") : " & vbNewLine & _
                   "    Serveur : " & sServer & vbNewLine & _
                   "    Base : " & sDatabase & vbNewLine & _
                   "    User : " & sUser & vbNewLine & _
                   "    Password : " & sPassword
        Else
            MessageBox "Dploiement (" & Format(Now, "dd/mm/yyyy hh:mm:ss") & ") : " & vbNewLine & _
                   "    Serveur : " & sServer & vbNewLine & _
                   "    Base : " & sDatabase & vbNewLine
        End If
    End If
                                 

try_file:
    Set Fs = CreateObject("Scripting.FileSystemObject")
    
    ''---------------------------------------------------------------
    '' Cas d'un fichier texte contenant la liste des fichier SQL  passer
    ''---------------------------------------------------------------
    If g_sTypeSelect = cmSelectFichierTexte Then
    
        Set oFileSource = Fs.OpenTextFile(sPath, cmOpenForReading, 0)
    
        Set colFiles = New CCollection
        Set colFilesTemp = New CCollection
             
        '' Parcours le fichier texte afin d'extraire les path des fichiers SQL
        bContinue = True
        While bContinue
            '' Lecture de la ligne courante
            sLine = oFileSource.ReadLine
            '' Ajout dans la collection
            colFilesTemp.AddIfAbsent sLine, sLine
        Wend
            
        '' Pour inverser l'ordre
        For lCpt = colFilesTemp.Count To 1 Step -1
            colFiles.Add colFilesTemp.Item(lCpt), colFilesTemp.Item(lCpt)
        Next
        
        '' En mode fentre, dfinit la ProgressBar
        If Not m_oCurForm Is Nothing Then
            m_oCurForm.ProgressBar_SetMaxStep colFiles.Count
        End If
        
        m_lTotal = colFiles.Count
        m_lLoaded = 0
        m_lNotLoaded = 0
        
        '' Pour chaque fichier SQL
        For lCpt = m_lTotal To 1 Step -1
            '' Rcupre le path du fichier
            sLine = colFiles.Item(lCpt)
            
            '' Si le fichier SQL n'est pas valide
            If LenB(sLine) = 0 Then
                m_lTotal = m_lTotal - 1
            
            '' Si le fichier SQL est valide
            Else
                '' Si son path est valide
                If Fs.FileExists(sLine) Then
                    '' Excute le fichier SQL
                    If ProcessFile(sLine) Then
                        '' Le supprime des fichiers SQL  traiter (au cas o il y a un pb sur un path)
                        colFiles.Remove sLine
                        '' Met  jour les compteurs
                        m_lLoaded = m_lLoaded + 1
                    Else
                        m_lNotLoaded = m_lNotLoaded + 1
                        
                        '' Si en mode ligne de commande, une erreur implique l'arrt du traitement
                        If m_lError = 0 Then
                            bMsgProcRestantes = True
                            lProcRestantes = lCpt - 1
                            Exit For
                        End If
                    End If
                
                '' Si son path n'est pas valide
                Else
                    '' Avertit l'utilisateur
                    lRet = MessageBox("Le fichier ou rpertoire '" & sLine & "' n'existe pas.", vbAbortRetryIgnore + vbExclamation, "AInstDB - Erreur")
                    
                    '' En mode fentre, l'utilisateur demande de ressayer tout le traitement
                    If lRet = vbRetry Then
                        oFileSource.Close: Set Fs = Nothing
                        GoTo try_file
                        
                    '' En mode fentre, l'utilisateur demande d'ignorer ce path
                    '' ou en mode ligne de commande, une erreur n'implique pas l'arrt du traitement
                    ElseIf lRet = vbIgnore Or m_lError <> 0 Then
                        m_lNotLoaded = m_lNotLoaded + 1
                    
                    '' En mode fentre, l'utilisateur demande de stopper le traitement
                    '' ou en mode ligne de commande, une erreur implique l'arrt du traitement
                    Else
                        m_lNotLoaded = m_lNotLoaded + 1
                        bMsgProcRestantes = True
                        lProcRestantes = lCpt - 1
                        Exit For
                    End If
                End If
            
                '' En mode fentre, dfinit la ProgressBar
                If Not m_oCurForm Is Nothing Then
                    m_oCurForm.ProgressBar_AddStep
                End If
            End If
        Next
        Set colFiles = Nothing: Set colFilesTemp = Nothing: Set oFileSource = Nothing
        
    ''---------------------------------------------------------------
    '' Cas d'un rpertoire contenant les fichier SQL  passer ou d'un fichier SQL unique
    ''---------------------------------------------------------------
    Else
        '' Si le path du fichier SQL unique existe
        If Fs.FileExists(sPath) Then
            m_lTotal = 1
            '' Excute le fichier SQL
            '' Et met  jour les compteurs
            If ProcessFile(sPath) Then
                m_lLoaded = 1
                m_lNotLoaded = 0
            Else
                m_lLoaded = 0
                m_lNotLoaded = 1
            End If
        
        '' Si le path du rpertoire existe
        ElseIf Fs.FolderExists(sPath) Then
            '' Excute les fichiers SQL du rpertoire
            lProcRestantes = ProcessDir(sPath)
            
            '' Si un fichier est en erreur
            '' et en mode ligne de commande, une erreur implique l'arrt du traitement
            If lProcRestantes <> 0 And m_lError = 0 Then bMsgProcRestantes = True
            
        '' Si le path n'est pas valide
        Else
            '' Avertit l'utilisateur
            '' Et lui demande si le traitement doit tre rejou
            If MessageBox("Le fichier ou rpertoire '" & sPath & "' n'existe pas.", vbRetryCancel + vbCritical, "AInstDB - Erreur") = vbRetry Then
                GoTo try_file
            End If
        End If
    End If
    
    '' Ferme la connexion
    m_oConnect.CloseConnection

    '' Log la fin de traitement (russi ou avort)
    lDuree = (GetTickCount - lDebut) / 1000
    If Not bMsgProcRestantes Then
        MessageBox "Nbr de procdures : " & CStr(m_lTotal) & vbNewLine & _
                   "Nbr de procdures charges : " & CStr(m_lLoaded) & vbNewLine & _
                   "Nbr de procdures rejettes : " & CStr(m_lNotLoaded) & vbNewLine & _
                   "Temps de chargement : " & CStr(Int(lDuree / 3600)) & "h" & CStr(Int((lDuree Mod 3600) / 60)) & "m" & CStr(Int(lDuree Mod 60)) & "s"
    Else
        MessageBox "Nbr de procdures : " & CStr(m_lTotal) & vbNewLine & _
                   "Nbr de procdures charges : " & CStr(m_lLoaded) & vbNewLine & _
                   "Nbr de procdures rejettes : " & CStr(m_lNotLoaded) & vbNewLine & _
                   "Nbr de procdures restantes  charger : " & CStr(lProcRestantes) & vbNewLine & _
                   "Temps de chargement : " & CStr(Int(lDuree / 3600)) & "h" & CStr(Int((lDuree Mod 3600) / 60)) & "m" & CStr(Int(lDuree Mod 60)) & "s"
    End If

    Set Fs = Nothing

Exit Sub

Error_Handler:
    Dim lErrNumber As Integer
    lErrNumber = Err.Number
    '' End of file: fin du fichier rencontre
    If lErrNumber = 62 Or lErrNumber = 0 Then
        bContinue = False
        Resume Next
        
    ElseIf lErrNumber = 70 Or lErrNumber = 53 Then
        Call MessageBox("Le fichier ou rpertoire '" & sPath & "' n'est pas accessible.", vbOK + vbCritical, "AInstDB - Erreur")
    End If
    
    Set colFiles = Nothing: Set colFilesTemp = Nothing: Set oFileSource = Nothing: Set Fs = Nothing
End Sub


Private Function ProcessFile(ByVal sFileName As String) As Boolean
    On Error GoTo Error_Handler
    
    Dim bRunQuery As Boolean
    Dim nIDFIle As Integer
    Dim nPos As Long, lenBuffer As Long
    Dim sBuffer As String, sQuery As String
    
    '' Ouvre le fichier SQL
    nIDFIle = FreeFile
    Open sFileName For Input As #nIDFIle
                    
    '' Rcupre son contenu
    lenBuffer = LOF(nIDFIle)
    sBuffer = Input(lenBuffer, nIDFIle)
    
    '' Rcupre le premier GO
    nPos = InStr(1, sBuffer, cmGoStatement, vbTextCompare)
       
    '' Tant qu'il y a des GO
    Do While nPos > 0
        '' Initialisation
        bRunQuery = False
        '' Doit jou la requte si le GO est bien un GO de traitement
        If nPos + 3 > lenBuffer Then
            bRunQuery = True
        ElseIf Asc(Mid$(sBuffer, nPos - 1, 1)) <= 32 And Asc(Mid$(sBuffer, nPos + 3, 1)) <= 32 Then
            bRunQuery = True
        End If
        
        '' Si la reqte doit tre joue
        If bRunQuery Then
            '' Rcupre le traitement
            sQuery = Left$(sBuffer, nPos - 1)
            '' L'excute en base
            m_oConnect.ExecuteQuery sQuery
            '' Rcupre le reste du contenu du fichier SQL
            lenBuffer = lenBuffer - (nPos + 1)
            sBuffer = Right$(sBuffer, lenBuffer)
            nPos = 1
        End If
        '' Recherche le prochain GO
        nPos = InStr(nPos + 1, sBuffer, cmGoStatement, vbTextCompare)
    Loop
    
    '' Excute en base l'unique GO ou le dernier
    If LenB(sBuffer) <> 0 Then
        m_oConnect.ExecuteQuery sBuffer
    End If
    
    '' Ferme le fichier SQL
    Close #nIDFIle
    
    '' Log le traitement russi
    LogMessage Dir(sFileName) & vbTab & "Russi"
    
    ProcessFile = True
    Exit Function

Error_Handler:
    '' Ferme le fichier SQL
    Close #nIDFIle
    '' Log le traitement chou
    LogMessage Dir(sFileName) & vbTab & Err.Description
    ProcessFile = False
End Function


Private Function ProcessDir(ByVal sPath As String) As Long
    Dim lCpt As Long
    Dim sFileName As String
    Dim colFiles As Collection

    '' Initialisation optimiste du traitement (pas d'erreur)
    ProcessDir = 0

    '' Extrait la premire entre
    sFileName = Dir(sPath & cmBackSlash & cmSQLFilesFilter, vbDirectory)
    
    Set colFiles = New Collection
    Do While sFileName <> ""
        '' Ignore le dossier courant et le dossier contenant le dossier courant
        If sFileName <> "." And sFileName <> ".." Then
            '' N'ajoute que les fichiers SQL du rpertoire (pas les sous rpertoires)
            If Not ((GetAttr(sPath & cmBackSlash & sFileName) And vbDirectory) = vbDirectory) Then
                colFiles.Add sPath & cmBackSlash & sFileName
            End If
        End If
        sFileName = Dir
    Loop
    
    m_lTotal = colFiles.Count
    
    m_lLoaded = 0
    m_lNotLoaded = 0
    '' S'il y a des fichiers SQL dans le rpertoire
    If m_lTotal > 0 Then
        '' En mode fentre, dfinit la ProgressBar
        If Not m_oCurForm Is Nothing Then
            m_oCurForm.ProgressBar_SetMaxStep colFiles.Count
        End If
    
        '' Pour chaque fichier SQL
        For lCpt = 1 To m_lTotal
            '' Excute le fichier SQL
            If ProcessFile(colFiles.Item(lCpt)) = True Then
                '' Met  jour les compteurs
                m_lLoaded = m_lLoaded + 1
            Else
                m_lNotLoaded = m_lNotLoaded + 1
                
                '' Si en mode ligne de commande, une erreur implique l'arrt du traitement
                If m_lError = 0 Then
                    ProcessDir = m_lTotal - lCpt
                    Exit For
                End If
            End If
            
            '' En mode fentre, dfinit la ProgressBar
            If Not m_oCurForm Is Nothing Then
                m_oCurForm.ProgressBar_AddStep
            End If
        Next lCpt
    End If
    
    Set colFiles = Nothing
End Function

Private Sub Class_Initialize()
    m_lLoaded = 0
    m_lNotLoaded = 0
End Sub


Private Sub LogMessage(ByVal sMessage As String)
    Dim nIDFIle As Integer
    
    If m_sLogFile = vbNullString And Not m_oCurForm Is Nothing Then
        m_oCurForm.lstErrProcs.AddItem sMessage
        m_oCurForm.Refresh
    Else
        nIDFIle = FreeFile
        Open m_sLogFile For Append As #nIDFIle
        Print #nIDFIle, Format(Now, "dd/mm/yyyy hh:mm:ss") & " - " & sMessage
        Close #nIDFIle
    End If
End Sub

Private Function MessageBox(ByVal sMessage As String, Optional ByVal vbBoxStyle As VbMsgBoxStyle, Optional ByVal sTitle As String) As VbMsgBoxResult
    On Error GoTo ErrorHandler
    
    Dim nIDFIle As Integer
    
    If m_sLogFile = vbNullString Then
        MessageBox = MsgBox(sMessage, vbBoxStyle, sTitle)
    Else
        nIDFIle = FreeFile
        Open m_sLogFile For Append As #nIDFIle
        Print #nIDFIle, "--------------------------------------------------------------"
        Print #nIDFIle, sMessage
        Print #nIDFIle, "--------------------------------------------------------------"
        Close #nIDFIle
        MessageBox = vbOK
    End If
    
    Exit Function
    
ErrorHandler:
    If Err.Number = 76 Then
        MkDir Left$(m_sLogFile, InStrRev(m_sLogFile, cmBackSlash))
        Resume
    End If
    Err.Raise Err.Number
End Function

